routes/web.php
<?php

use Illuminate\Support\Facades\Route;
/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

Route::get('/','IndexController@index');
Route::get('about', 'IndexController@about');
Route::get('contact', 'IndexController@contact');
Route::get('work','IndexController@work');
Route::get('/details/{id}','IndexController@details');
Route::get('posts/show-work/{id}','IndexController@showWork');
Route::get('search','IndexController@search');
Route::get('/send-mail', 'MailController@sendEmail');

Route::get('lang/{locale}', 'LocalizationController@index');
Auth::routes(['register' => false]);

Route::get('/home', 'HomeController@index')->name('home');

Route::resource('post-types','PostTypeController');
Route::resource('posts','PostController');
Route::delete('posts/delete-image/{id}','PostController@deleteImage');
Route::resource('users','UserController');
Route::get('users/edit-password/{id}','UserController@editPassword');
Route::post('users/change-password/{id}','UserController@changePassword');
Route::resource('slide-images','SlideImagesController');

app/SlideImages.php
<?php

namespace App;

use Illuminate\Database\Eloquent\Model;

class SlideImages extends Model
{
    protected $fillable = ['title_kh','title_en','content_kh','content_en','path','is_published'];

    public function slideimages($id)
    {
        return SlideImages::find($id); 
    }
}

app/Http/Controllers/SlideImagesController.php
<?php

namespace App\Http\Controllers;

use App\SlideImages;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\Storage;
use Image;

class SlideImagesController extends Controller
{
    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index()
    {
        $post = SlideImages::get(); 
        return view('slide_images.index',['post'=>$post]);
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create()
    {
        return view('slide_images.create');
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\Response
     */
    public function store(Request $request)
    {
        request()->validate([
            'title_en' => 'required',
            'title_kh' => 'required',
            'content_en' => 'required',
            'content_kh' => 'required',
            'thumbnail' => 'required',
            'thumbnail.*' => 'mimes:jpg,jpeg,png,gif',
        ]);

        if($imageFiles = $request->file('thumbnail')){
                $name = $imageFiles->getClientOriginalName();
                $mimetype = number_format($imageFiles->getSize()/1048576,3).' MB'; 
                $path = $imageFiles->storeAs('public/slideimages', $name);
                SlideImages::create([
                    'title_en' => $request->title_en,
                    'title_kh' => $request->title_kh,
                    'content_en' => $request->content_en,
                    'content_kh' => $request->content_kh,
                    'path' => $path,
                    'is_published' => $request->status,
                ]);
            }


        return redirect()->route('slide-images.index')
                        ->with('success','Slide images has been uploaded successfully.');
    }

    /**
     * Display the specified resource.
     *
     * @param  \App\Attachment  $attachment
     * @return \Illuminate\Http\Response
     */
    public function show($id)
    {
        $post = SlideImages::find($id); 
        return view('slide_images.show',['post'=>$post]);
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  \App\Attachment  $attachment
     * @return \Illuminate\Http\Response
     */
    public function edit($id)
    {
        //
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  \App\Attachment  $attachment
     * @return \Illuminate\Http\Response
     */
    public function update(Request $request, $id)
    {
        request()->validate([
            'title_en' => 'required',
            'title_kh' => 'required',
            'content_en' => 'required',
            'content_kh' => 'required',
        ]);

        $slide = SlideImages::find($id);
        if($imageFiles = $request->file('thumbnail')){
            $name = $imageFiles->getClientOriginalName();
            $mimetype = number_format($imageFiles->getSize()/1048576,3).' MB'; 
            $path = $imageFiles->storeAs('public/slideimages', $name);
            if($slide->path){
                $this->deleteFile($slide->path);
            }
            $slide->path = $path;
            
        }
        $slide->title_en = $request->title_en;
        $slide->title_kh = $request->title_kh;
        $slide->content_en = $request->content_en;
        $slide->content_kh = $request->content_kh;
        $slide->is_published = $request->status;
        $slide->save();

        return redirect()->route('slide-images.index')
                        ->with('success','Slide images has been updated successfully.');
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param  \App\SlideImages  $attachment
     * @return \Illuminate\Http\Response
     */
    public function destroy($id)
    {
        $attachemnt = SlideImages::find($id);
        $this->deleteFile($attachemnt->path);
        $attachemnt->delete();
        return back()->with('success', 'The image has been deleted successfully!');
    }

    /**
     * Undocumented function
     *
     * @param [type] $path
     * @return void
     */
    public function deleteFile($path){
        if($path){
            try{
                Storage::delete($path);
            }catch(\Exception $e){
                echo 'Caught exception: ',  $e->getMessage(), "\n";
            }
        }
    }
}

resources/views/slide_images/create.blade.php
@extends('layouts.app')
@section('css')
    <style>
        .float-right {
            margin-top: -40px;
        }

        #preview {
            max-height: 180px;
            height: auto;
            width: 300px;
            display: block;
            margin-left: auto;
            margin-right: auto;
            padding: 5px;
        }

        #img_container {
            border-radius: 5px;
            margin-top: 3px;
            margin-bottom: 3px;
            width: auto;
        }

        .imgInp {
            display: none;
            margin-top: 10px;
            padding: 10px;
        }

        .addImg {
            display: none;
            margin-top: 10px;
            padding: 10px;
        }

        @keyframes blinkingText {
            0% {
                color: #000;
            }

            50% {
                color: #transparent;
            }

            99% {
                color: transparent;
            }

            100% {
                color: #000;
            }
        }

        .custom-file-label {
            cursor: pointer;
        }

        .c-input-h {
            height: 38px;
        }

        .clone {
            display: none;
        }

        .photo-thumbnail {
            width: 220px;
            height: 120px;
            border-radius: 4px;
            margin-right: 5px;
        }

        .remove-img {
            display: none;
            margin-top: -120px;
            position: relative;
            margin-right: 48px;
            padding: 5px 15px 5px 15px;
        }

        .image-answer:hover .remove-img {
            display: block;
        }

    </style>
@endsection
@section('content')
    <div class="page-title">
        <div class="row">
            <div class="col-12 col-md-6 order-md-1 order-last">
                <h3>Slide Images</h3>
                <p class="text-subtitle text-muted">User can create by below.</p>
            </div>
            <div class="col-12 col-md-6 order-md-2 order-first">
                <nav aria-label="breadcrumb" class='breadcrumb-header'>
                    <ol class="breadcrumb">
                        <li class="breadcrumb-item"><a href="{{ route('slide-images.index') }}">Slide Images</a></li>
                        <li class="breadcrumb-item active" aria-current="page">Create Slide Images</li>
                    </ol>
                </nav>
                @include('flash-message')
            </div>
        </div>
    </div>

    <section class="section">
        <div class="col-md-12">
            <div class="card">
                <form action="{{ route('slide-images.store') }}" method="post" enctype="multipart/form-data" id="form1">
                    @csrf
                    <div class="card-header">
                        <h4 class="card-title">Slide Images</h4>
                        <div class="float-right">
                            <a href="{{ route('slide-images.index') }}" class="btn btn-danger"><i data-feather="x"></i>
                                Close</a>
                            <button type="submit" class="btn btn-primary save-button"><i data-feather="save"></i>
                                Save</button>
                        </div>
                    </div>

 <div class="card-body">
                        <div class="row">
                            <div class="col-md-6">
                               
                                <div class="form-group">
                                    <label for="helperText">THUMBNAIL [Maximum Size: 1900px × 1080px]</label>
                                    <div id='img_container'>
                                        <img id="preview" src="{{ asset('img/placeholder.png') }}" alt="your image"
                                            title='' />
                                    </div>
                                    <div class="input-group">
                                        <input type="file" id="inputGroupFile01" name="thumbnail"
                                            class="imgInp custom-file-input" aria-describedby="inputGroupFileAddon01"
                                            accept="image/*" value="">
                                        <label class="form-control custom-file-label"
                                            for="inputGroupFile01">Thumbnail</label>
                                        <button class="btn btn-primary" type="button" id="chooseThumbnail">Choose
                                            Thumbnail</button>
                                    </div>
                                    <p><small class="text-red">{{ $errors->first('thumbnail') }}</small></p>
                                </div>
                                <div class="form-group" style="margin-top: -6px !important;">
                                    <label for="exampleFormControlTextarea1" class="form-label">CONTENT (AS English)</label>
                                    <textarea class="form-control" name="content_en" rows="3"></textarea>
                                    <p><small class="text-red">{{ $errors->first('content_en') }}</small></p>
                                </div>
                            </div>
                            <div class="col-md-6">
                                 <div class="form-group">
                                    <label for="basicInput">Title (AS ENGLISH)</label>
                                    <input type="text" class="form-control" name="title_en" placeholder="Enter title"
                                        value="">
                                    <p><small class="text-red">{{ $errors->first('title_en') }}</small></p>
                                </div>
                                <div class="form-group">
                                    <label for="basicInput">Title (AS KHMER)</label>
                                    <input type="text" class="form-control" name="title_kh" placeholder="Enter title"
                                        value="">
                                    <p><small class="text-red">{{ $errors->first('title_kh') }}</small></p>
                                </div>
                                <br><br>
                                <div class="form-group">
                                    <label for="helperText">Status</label>
                                    <div class="form-group">
                                        <select class="choices form-select status" id="status" name="status">
                                            <option value="0">Draft</option>
                                            <option value="1">Published</option>
                                        </select>
                                    </div>
                                </div>
                                <div class="form-group">
                                    <label for="exampleFormControlTextarea1" class="form-label">CONTENT (AS KHMER)</label>
                                    <textarea class="form-control" name="content_kh" rows="3"></textarea>
                                    <p><small class="text-red">{{ $errors->first('content_kh') }}</small></p>
                                </div>
                            </div>
                        </div>
                    </div>
                </form>
            </div>
        </div>
    </section>
@endsection

@section('js')
    <script type="text/javascript">
        $(document).ready(function() {
            $("#inputGroupFile01").change(function(event) {
                readURL(this);
            });

            function readURL(input) {
                if (input.files && input.files[0]) {
                    var reader = new FileReader();
                    var filename = $("#inputGroupFile01").val();
                    filename = filename.substring(filename.lastIndexOf('\\') + 1);
                    reader.onload = function(e) {
                        debugger;
                        $('#preview').attr('src', e.target.result);
                        $('#preview').hide();
                        $('#preview').fadeIn(500);
                        $('.custom-file-label').text(filename);
                    }
                    reader.readAsDataURL(input.files[0]);
                }
            }
        });

    </script>
@endsection

resources/views/slide_images/index.blade.php
@extends('layouts.app')
@section('css')
    <style>
        .float-right {
            margin-top: -40px;
        }

        #preview {
            max-height: 180px;
            height: auto;
            width: 300px;
            display: block;
            margin-left: auto;
            margin-right: auto;
            padding: 5px;
        }

        #img_container {
            border-radius: 5px;
            margin-top: 3px;
            margin-bottom: 3px;
            width: auto;
        }

        .imgInp {
            display: none;
            margin-top: 10px;
            padding: 10px;
        }

        .save-button {
            display: none;
        }

        @keyframes blinkingText {
            0% {
                color: #000;
            }

            50% {
                color: #transparent;
            }

            99% {
                color: transparent;
            }

            100% {
                color: #000;
            }
        }

        .custom-file-label {
            cursor: pointer;
        }

        #add_more {
            display: none;
        }

        .photo-thumbnail {
            width: 220px;
            height: 120px;
            border-radius: 4px;
            margin-right: 5px;
        }

        .remove-img {
            display: none;
            margin-top: -120px;
            position: relative;
            margin-right: 48px;
            padding: 5px 15px 5px 15px;
        }

    </style>
@endsection
@section('content')
    <div class="page-title">
        <div class="row">
            <div class="col-12 col-md-6 order-md-1 order-last">
                <h3>Slide Images</h3>
                <p class="text-subtitle text-muted">User can create by below. <a href="{{ route('slide-images.create') }}"
                        class="btn icon icon-left btn-primary"><i data-feather="plus"></i> Create</a></p>
            </div>
            <div class="col-12 col-md-6 order-md-2 order-first">
                <nav aria-label="breadcrumb" class='breadcrumb-header'>
                    <ol class="breadcrumb">
                        <li class="breadcrumb-item"><a href="{{ route('slide-images.index') }}">Slide Images</a></li>
                        <li class="breadcrumb-item active" aria-current="page">Create Slide Images</li>
                    </ol>
                </nav>
                @include('flash-message')
            </div>
        </div>
    </div>
    <br>
    <section class="section">
        <div class="row">
            @foreach ($post as $i => $item)
                <div class="col-xl-3 col-md-4 col-sm-6">
                    <div class="card">
                        <div class="card-content">
                            <img class="card-img-top img-fluid" src="{{ Storage::url($item->path) }}" alt="Card image cap">
                            <div class="card-body">
                                <h4 class="card-title">{{ Session::get('locale') == 'kh' ? $item->title_kh : $item->title_en }}</h4>
                                <p class="card-text">
                                    {{ Session::get('locale') == 'kh' ? Illuminate\Support\Str::limit($item->content_kh, 200) : Illuminate\Support\Str::limit($item->content_en, 200) }}
                                </p>
                                <a class="btn btn-primary block" href="{{ route('slide-images.show', $item->id) }}">Edit</a>
                                <a class="btn btn-danger block confirmation ml-3" href="#" data-toggle="modal"
                                    data-target="#small-modal" data-id="{{ $item->id }}">Delete</a>
                            </div>
                        </div>
                    </div>
                </div>
            @endforeach
        </div>
        <div class="modal fade text-left modal-borderless fade" tabindex="-1" role="dialog" id="small-modal"
            style="display: none; padding-left: 0px;" aria-modal="true">
            <div class="modal-dialog modal-sm" role="document">
                <div class="modal-content">
                    <div class="modal-header">
                        <h5 class="modal-title">Confirmation</h5><button type="button" class="close" data-dismiss="modal"
                            aria-label="Close"><span aria-hidden="true">×</span></button>
                    </div>
                    <div class="modal-body">
                        <p>Are you sure to delete the selected record ?</p>
                    </div>
                    <div class="modal-footer">
                        <button type="button" class="btn btn-primary btn-sm" data-dismiss="modal"><i
                                class="mdi mdi-close"></i>
                            Close</button>
                        <form action="" method="post" id="form">
                            @method('DELETE')
                            @csrf
                            <button type="submit" class="btn btn-sm btn-danger"><i class="mdi mdi-delete"></i>
                                Delete</button>
                        </form>
                    </div>
                </div>
            </div>
    </section>
@endsection
@section('js')
    <script type="text/javascript">
        $(document).ready(function() {

            $('.confirmation').click(function() {
                $('#form').attr('action', "slide-images/" + $(this).attr('data-id'));
            })

        });

    </script>
@endsection

resources/views/slide_images/show.blade.php
@extends('layouts.app')
@section('css')
    <style>
        .float-right {
            margin-top: -40px;
        }

        #preview {
            max-height: 180px;
            height: auto;
            width: 300px;
            display: block;
            margin-left: auto;
            margin-right: auto;
            padding: 5px;
        }

        #img_container {
            border-radius: 5px;
            margin-top: 3px;
            margin-bottom: 3px;
            width: auto;
        }

        .imgInp {
            display: none;
            margin-top: 10px;
            padding: 10px;
        }

        .addImg {
            display: none;
            margin-top: 10px;
            padding: 10px;
        }

        @keyframes blinkingText {
            0% {
                color: #000;
            }

            50% {
                color: #transparent;
            }

            99% {
                color: transparent;
            }

            100% {
                color: #000;
            }
        }

        .custom-file-label {
            cursor: pointer;
        }

        .c-input-h {
            height: 38px;
        }

        .clone {
            display: none;
        }

        .photo-thumbnail {
            width: 220px;
            height: 120px;
            border-radius: 4px;
            margin-right: 5px;
        }

        .remove-img {
            display: none;
            margin-top: -120px;
            position: relative;
            margin-right: 48px;
            padding: 5px 15px 5px 15px;
        }

        .image-answer:hover .remove-img {
            display: block;
        }

    </style>
@endsection
@section('content')
    <div class="page-title">
        <div class="row">
            <div class="col-12 col-md-6 order-md-1 order-last">
                <h3>Slide Images</h3>
                <p class="text-subtitle text-muted">User can create by below.</p>
            </div>
            <div class="col-12 col-md-6 order-md-2 order-first">
                <nav aria-label="breadcrumb" class='breadcrumb-header'>
                    <ol class="breadcrumb">
                        <li class="breadcrumb-item"><a href="{{ route('slide-images.index') }}">Slide Images</a></li>
                        <li class="breadcrumb-item active" aria-current="page">Create Slide Images</li>
                    </ol>
                </nav>
                @include('flash-message')
            </div>
        </div>
    </div>

    <section class="section">
        <div class="col-md-12">
            <div class="card">
                <form action="{{ route('slide-images.update', $post->id) }}" method="post" enctype="multipart/form-data" id="form1">
                    @method('PATCH')
                    @csrf
                    <div class="card-header">
                        <h4 class="card-title">Slide Images</h4>
                        <div class="float-right">
                            <a href="{{ route('slide-images.index') }}" class="btn btn-danger"><i data-feather="x"></i>
                                Close</a>
                            <button type="submit" class="btn btn-primary save-button"><i data-feather="save"></i>
                                Save</button>
                        </div>
                    </div>

                    <div class="card-body">
                        <div class="row">
                            <div class="col-md-6">

                                <div class="form-group">
                                    <label for="helperText">THUMBNAIL [MAXIMUM SIZE: 1900PX × 1080PX]</label>
                                    <div id='img_container'>
                                        <img id="preview" src="{{ Storage::url($post->path) }}" alt="thumbnail">
                                        @if (!asset($post->path))
                                            <img id="preview"
                                                src="https://webdevtrick.com/wp-content/uploads/preview-img.jpg"
                                                alt="your image" title='' />
                                        @endif
                                    </div>
                                    <div class="input-group">
                                        <input type="file" id="inputGroupFile01" name="thumbnail"
                                            class="imgInp custom-file-input" aria-describedby="inputGroupFileAddon01"
                                            accept="image/*" value="{{ Storage::url($post->path) }}">
                                        <label class="form-control custom-file-label"
                                            for="inputGroupFile01">Thumbnail</label>
                                        <button class="btn btn-primary" type="button" id="chooseThumbnail">Choose
                                            Thumbnail</button>
                                    </div>
                                    <p><small class="text-red">{{ $errors->first('thumbnail') }}</small></p>
                                </div>
                                <div class="form-group" style="margin-top: -6px !important;">
                                    <label for="exampleFormControlTextarea1" class="form-label">CONTENT (AS English)</label>
                                <textarea class="form-control" name="content_en" rows="3">{{ $post->content_en}}</textarea>
                                    <p><small class="text-red">{{ $errors->first('content_en') }}</small></p>
                                </div>
                            </div>
                            <div class="col-md-6">
                                <div class="form-group">
                                    <label for="basicInput">Title (AS ENGLISH)</label>
                                    <input type="text" class="form-control" name="title_en" placeholder="Enter title"
                                        value="{{ $post->title_en}}">
                                    <p><small class="text-red">{{ $errors->first('title_en') }}</small></p>
                                </div>
                                <div class="form-group">
                                    <label for="basicInput">Title (AS KHMER)</label>
                                    <input type="text" class="form-control" name="title_kh" placeholder="Enter title"
                                        value="{{ $post->title_kh}}">
                                    <p><small class="text-red">{{ $errors->first('title_kh') }}</small></p>
                                </div>
                                <br><br>
                                <div class="form-group">
                                    <label for="helperText">Status</label>
                                    <div class="form-group">
                                        <select class="choices form-select status" id="status" name="status">
                                            <option value="0">Draft</option>
                                            <option value="1">Published</option>
                                        </select>
                                    </div>
                                </div>
                                <div class="form-group">
                                    <label for="exampleFormControlTextarea1" class="form-label">CONTENT (AS KHMER)</label>
                                    <textarea class="form-control" name="content_kh" rows="3">{{ $post->content_kh}}</textarea>
                                    <p><small class="text-red">{{ $errors->first('content_kh') }}</small></p>
                                </div>
                            </div>
                        </div>
                    </div>
                </form>
            </div>
        </div>
    </section>
@endsection

@section('js')
    <script type="text/javascript">
        $(document).ready(function() {
            $("#inputGroupFile01").change(function(event) {
                readURL(this);
            });

            function readURL(input) {
                if (input.files && input.files[0]) {
                    var reader = new FileReader();
                    var filename = $("#inputGroupFile01").val();
                    filename = filename.substring(filename.lastIndexOf('\\') + 1);
                    reader.onload = function(e) {
                        debugger;
                        $('#preview').attr('src', e.target.result);
                        $('#preview').hide();
                        $('#preview').fadeIn(500);
                        $('.custom-file-label').text(filename);
                    }
                    reader.readAsDataURL(input.files[0]);
                }
            }
        });

    </script>
@endsection